import type { HyperConstructor, HyperRaw, HyperVal } from '../Hyper';
import { Hyper } from '../Hyper';
import type { Trace } from '../Trace';
declare type Reflect<T> = T extends infer U ? {
    [K in keyof U]: U[K];
} : never;
declare type Optional<T extends {
    [i: string]: any;
}> = {
    [K in keyof T]: void extends T[K] ? K : never;
}[keyof T];
declare type Required<T extends {
    [i: string]: any;
}> = {
    [K in keyof T]: void extends T[K] ? never : K;
}[keyof T];
declare type UndefinedIsOptional<T> = Reflect<{
    [K in Required<T>]: T[K];
} & {
    [K in Optional<T>]?: T[K] extends (infer U | void) ? (U | undefined) : never;
}>;
export declare function is_object<T extends {
    [i: string]: unknown;
}>(raw: any, failure: Trace): asserts raw is T;
export declare class HyperObject<T extends {
    [K: string]: Hyper<any, any>;
}> extends Hyper<UndefinedIsOptional<{
    [K in keyof T]: HyperRaw<T[K]>;
}>, UndefinedIsOptional<{
    [K in keyof T]: HyperVal<T[K]>;
}>> {
    /**
     * Object schema
     */
    readonly schema: T;
    constructor(
    /**
     * Object schema
     */
    schema: T, ...hyper: HyperConstructor<UndefinedIsOptional<{
        [K in keyof T]: HyperVal<T[K]>;
    }>>);
}
export declare function object_core<T extends {
    [K: string]: Hyper<any, any>;
}>(check_length: boolean, value: T): HyperObject<T>;
export {};
