import type { HyperConstructor, HyperRaw, HyperVal } from '../Hyper';
import { Hyper } from '../Hyper';
export declare class HyperRecord<T extends Hyper<string>, U extends Hyper<any, any>> extends Hyper<{
    [K in HyperRaw<T>]?: HyperRaw<U>;
}, {
    [K in HyperVal<T>]?: HyperVal<U>;
}> {
    /**
     * Record Schema
     */
    readonly schema: {
        /** Key */
        key: T;
        /** Value */
        val: U;
    };
    constructor(
    /**
     * Record Schema
     */
    schema: {
        /** Key */
        key: T;
        /** Value */
        val: U;
    }, ...hyper: HyperConstructor<{
        [K in HyperVal<T>]?: HyperVal<U>;
    }>);
}
/**
 * Validates a value to be a generic object of `{ [key]: value }`
 *
 * @param keyhyper Key value.
 * @param valhyper Data value.
 */
export declare function record<T extends Hyper<string>, U extends Hyper<any, any>>(keyhyper: T, valhyper: U): HyperRecord<T, U>;
