import type { HyperConstructor, HyperRaw, HyperVal } from '../Hyper';
import { Hyper } from '../Hyper';
export declare class HyperOptional<T extends Hyper<any, any>> extends Hyper<HyperRaw<T> | void, HyperVal<T> | void> {
    /** Unoptional schema */
    readonly schema: T;
    constructor(
    /** Unoptional schema */
    schema: T, ...hyper: HyperConstructor<HyperVal<T>>);
}
/**
 * Makes a test accept undefined.
 * Use {@link literal} if you want a literal undefined.
 *
 * @param hyper Hyper to accept undefined.
 */
export declare function optional<T extends Hyper<any, any>>(hyper: T): HyperOptional<T>;
