import { Hyper } from '../Hyper';
import { is_object } from './object-core';
export class HyperRecord extends Hyper {
    constructor(
    /**
     * Record Schema
     */
    schema, ...hyper) {
        super(...hyper);
        this.schema = schema;
    }
}
/**
 * Validates a value to be a generic object of `{ [key]: value }`
 *
 * @param keyhyper Key value.
 * @param valhyper Data value.
 */
export function record(keyhyper, valhyper) {
    return new HyperRecord({ key: keyhyper, val: valhyper }, 'record', function (raw, failure) {
        is_object(raw, failure);
        const result = {};
        for (const [k, v] of Object.entries(raw)) {
            result[keyhyper.hyper(k, failure.fork(k))] = valhyper.hyper(v, failure.fork(k));
        }
        return result;
    });
}
