import { Hyper } from '../Hyper';
export class HyperOptional extends Hyper {
    constructor(
    /** Unoptional schema */
    schema, ...hyper) {
        super(...hyper);
        this.schema = schema;
    }
}
/**
 * Makes a test accept undefined.
 * Use {@link literal} if you want a literal undefined.
 *
 * @param hyper Hyper to accept undefined.
 */
export function optional(hyper) {
    return new HyperOptional(hyper, 'optional', function (raw, failure) {
        if (raw === undefined)
            return raw;
        return hyper.hyper(raw, failure);
    });
}
